<?php
/**
 * Business Solutions Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package business_solutions
 */

if( ! function_exists( 'business_solutions_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function business_solutions_customize_register( $wp_customize ) {
    require get_parent_theme_file_path('/inc/controls/changeable-icon.php');
    

    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'business-solutions' );
    }
	
    /* Option list of all post */	
    $business_solutions_options_posts = array();
    $business_solutions_options_posts_obj = get_posts('posts_per_page=-1');
    $business_solutions_options_posts[''] = esc_html__( 'Choose Post', 'business-solutions' );
    foreach ( $business_solutions_options_posts_obj as $business_solutions_posts ) {
    	$business_solutions_options_posts[$business_solutions_posts->ID] = $business_solutions_posts->post_title;
    }
    
    /* Option list of all categories */
    $business_solutions_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $business_solutions_option_categories = array();
    $business_solutions_category_lists = get_categories( $business_solutions_args );
    $business_solutions_option_categories[''] = esc_html__( 'Choose Category', 'business-solutions' );
    foreach( $business_solutions_category_lists as $business_solutions_category ){
        $business_solutions_option_categories[$business_solutions_category->term_id] = $business_solutions_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'business-solutions' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'business-solutions' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */
    
    /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => true,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'business-solutions' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'business-solutions' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'business-solutions'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '100', 
    ));

    $wp_customize->add_setting( 'business_solutions_site_title_size', array(
        'default'           => 30, // Default font size in pixels
        'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
    ) );

    // Add control for site title size
    $wp_customize->add_control( 'business_solutions_site_title_size', array(
        'type'        => 'number',
        'section'     => 'title_tagline', // You can change this section to your preferred section
        'label'       => __( 'Site Title Font Size (px)', 'business-solutions' ),
        'input_attrs' => array(
            'min'  => 10,
            'max'  => 100,
            'step' => 1,
        ),
    ) );

    //Global Color
    $wp_customize->add_section(
        'business_solutions_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'business-solutions' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'business_solutions_general_settings',
        )
    );

    $wp_customize->add_setting('business_solutions_primary_color', array(
        'default'           => '#078586',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'business_solutions_primary_color', array(
        'label'    => __('Theme Primary Color', 'business-solutions'),
        'section'  => 'business_solutions_global_color',
        'settings' => 'business_solutions_primary_color',
    )));    


    /** Home Page Settings */
    $wp_customize->add_panel( 
        'business_solutions_post_settings',
         array(
            'priority' => 11,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'business-solutions' ),
            'description' => esc_html__( 'Customize Post & Pages Settings', 'business-solutions' ),
        ) 
    );

        /** Post Layouts */
    
    $wp_customize->add_section(
        'business_solutions_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'business-solutions' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'business_solutions_post_settings',
        )
    );

    $wp_customize->add_setting('business_solutions_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'business_solutions_sanitize_post_layout',
    ));

    $wp_customize->add_control('business_solutions_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'business-solutions'),
        'section'  => 'business_solutions_post_layout_section',
        'settings' => 'business_solutions_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'business-solutions'),
            'left-sidebar'   => __('Left Sidebar', 'business-solutions'),
            'one-column'   => __('One Column', 'business-solutions'),
            'three-column'   => __('Three Columns', 'business-solutions'),
            'four-column'   => __('Four Columns', 'business-solutions'),
            'grid-layout'   => __('Grid Layout', 'business-solutions')
        ),
    ));

     /** Post Layouts Ends */
     
    /** Post Settings */
    $wp_customize->add_section(
        'business_solutions_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'business-solutions' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'business_solutions_post_settings',
        )
    );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'business_solutions_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'business-solutions' ),
            'section'     => 'business_solutions_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'business_solutions_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'business-solutions' ),
            'section'     => 'business_solutions_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'business_solutions_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'business-solutions' ),
            'section'     => 'business_solutions_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'business_solutions_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'business-solutions' ),
            'section'     => 'business_solutions_post_settings',
            'type'        => 'checkbox',
        )
    );
    /** Post ReadMore control */
     $wp_customize->add_setting( 'business_solutions_read_more_setting', array(
        'default'           => true,
        'sanitize_callback' => 'business_solutions_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'business_solutions_read_more_setting', array(
        'type'        => 'checkbox',
        'section'     => 'business_solutions_post_settings', 
        'label'       => __( 'Display Read More Button', 'business-solutions' ),
    ) );

    /** Post Settings Ends */

     /** Single Post Settings */
    $wp_customize->add_section(
        'business_solutions_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'business-solutions' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'business_solutions_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'business_solutions_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'business-solutions' ),
            'section'     => 'business_solutions_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'business_solutions_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'business-solutions' ),
            'section'     => 'business_solutions_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Settings Ends */

         // Typography Settings Section
    $wp_customize->add_section('business_solutions_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'business-solutions'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'business_solutions_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'business-solutions'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Roboto'         => 'Roboto, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('business_solutions_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'business_solutions_sanitize_choicess',
    ));
    $wp_customize->add_control('business_solutions_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'business-solutions'),
        'section' => 'business_solutions_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('business_solutions_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'business_solutions_sanitize_choicess',
    ));
    $wp_customize->add_control('business_solutions_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'business-solutions'),
        'section' => 'business_solutions_typography_settings',
    ));

    /** Typography Settings Section End */

        /** Home Page Settings */
    $wp_customize->add_panel( 
        'business_solutions_general_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'business-solutions' ),
            'description' => esc_html__( 'Customize General Settings', 'business-solutions' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'business_solutions_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'business-solutions' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'business_solutions_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'business_solutions_header_preloader', 
        array(
            'default' => false,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_header_preloader',
        array(
            'label'       => __( 'Show Preloader', 'business-solutions' ),
            'section'     => 'business_solutions_general_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('business_solutions_loader_layout_setting', array(
        'default' => 'load',
        'sanitize_callback' => 'sanitize_text_field',
    ));

    // Add control for loader layout
    $wp_customize->add_control('business_solutions_loader_layout_control', array(
        'label' => __('Preloader Layout', 'business-solutions'),
        'section' => 'business_solutions_general_settings',
        'settings' => 'business_solutions_loader_layout_setting',
        'type' => 'select',
        'choices' => array(
            'load' => __('Preloader 1', 'business-solutions'),
            'load-one' => __('Preloader 2', 'business-solutions'),
            'ctn-preloader' => __('Preloader 3', 'business-solutions'),
        ),
    ));

    /** Header Section Settings */
    $wp_customize->add_section(
        'business_solutions_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'business-solutions' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'business_solutions_home_page_settings',
        )
    );

        /** Appointment Button */
    $wp_customize->add_setting(
        'business_solutions_header_signin_link',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'business_solutions_header_signin_link',
        array(
            'label' => esc_html__( 'Sign Up URL', 'business-solutions' ),
            'section' => 'business_solutions_header_section_settings',
            'type' => 'url',
        )
    );

    /** Sticky Header control */
    $wp_customize->add_setting( 
        'business_solutions_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'business-solutions' ),
            'section'     => 'business_solutions_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'business_solutions_menu_font_weight', array(
        'default'           => '300',
        'sanitize_callback' => 'business_solutions_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'business_solutions_menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'business-solutions' ),
        'section'  => 'business_solutions_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'business-solutions' ),
            '200' => __( '200 - Extra Light', 'business-solutions' ),
            '300' => __( '300 - Light', 'business-solutions' ),
            '400' => __( '400 - Normal', 'business-solutions' ),
            '500' => __( '500 - Medium', 'business-solutions' ),
            '600' => __( '600 - Semi Bold', 'business-solutions' ),
            '700' => __( '700 - Bold', 'business-solutions' ),
            '800' => __( '800 - Extra Bold', 'business-solutions' ),
            '900' => __( '900 - Black', 'business-solutions' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'business_solutions_menu_text_transform', array(
        'default'           => 'Capitalize',
        'sanitize_callback' => 'business_solutions_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'business_solutions_menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'business-solutions' ),
        'section'  => 'business_solutions_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'business-solutions' ),
            'capitalize' => __( 'Capitalize', 'business-solutions' ),
            'uppercase'  => __( 'Uppercase', 'business-solutions' ),
            'lowercase'  => __( 'Lowercase', 'business-solutions' ),
        ),
    ) );

    $wp_customize->add_setting('business_solutions_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'business_solutions_sanitize_choices'
	));
	$wp_customize->add_control('business_solutions_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','business-solutions'),
		'section' => 'business_solutions_header_section_settings',
		'choices' => array(
         'None' => __('None','business-solutions'),
         'Zoom In' => __('Zoom In','business-solutions'),
      ),
	));

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'business_solutions_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'business-solutions' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'business-solutions' ),
        ) 
    );

 /** Slider Section Settings */
    $wp_customize->add_section(
        'business_solutions_slider_section_settings',
        array(
            'title' => esc_html__( 'Banner Section Settings', 'business-solutions' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'business_solutions_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'business_solutions_slider_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_slider_setting',
        array(
            'label'       => __( 'Show Slider', 'business-solutions' ),
            'section'     => 'business_solutions_slider_section_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('business_solutions_slider_background_image',
        array(
            'sanitize_callback' => 'esc_url_raw',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Image_Control( $wp_customize,'business_solutions_slider_background_image',
            array(
                'label' => __('Slider Background Image','business-solutions'),
                'section' => 'business_solutions_slider_section_settings',
                'settings' => 'business_solutions_slider_background_image',
            )
        )
    );


    // Section Text
    $wp_customize->add_setting('business_solutions_slider_text_extra', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('business_solutions_slider_text_extra', 
        array(
        'label'       => __('Banner Extra Title', 'business-solutions'),
        'section'     => 'business_solutions_slider_section_settings',   
        'settings'    => 'business_solutions_slider_text_extra',
        'type'        => 'text'
        )
    );

        // Section Text
    $wp_customize->add_setting('business_solutions_slider_heading', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('business_solutions_slider_heading', 
        array(
        'label'       => __('Banner Heading', 'business-solutions'),
        'section'     => 'business_solutions_slider_section_settings',   
        'settings'    => 'business_solutions_slider_heading',
        'type'        => 'text'
        )
    );

    // Section Text
    $wp_customize->add_setting('business_solutions_slider_content', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('business_solutions_slider_content', 
        array(
        'label'       => __('Banner Content', 'business-solutions'),
        'section'     => 'business_solutions_slider_section_settings',   
        'settings'    => 'business_solutions_slider_content',
        'type'        => 'text'
        )
    );

        $wp_customize->add_setting(
        'business_solutions_banner_btn_text',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'business_solutions_banner_btn_text',
        array(
            'label' => esc_html__( 'Add Button Text', 'business-solutions' ),
            'section' => 'business_solutions_slider_section_settings',
            'type' => 'text',
        )
    );

    /** Banner Button */
    $wp_customize->add_setting(
        'business_solutions_banner_btn_url',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'business_solutions_banner_btn_url',
        array(
            'label' => esc_html__( 'Add Button URL', 'business-solutions' ),
            'section' => 'business_solutions_slider_section_settings',
            'type' => 'url',
        )
    );

    $wp_customize->add_setting('business_solutions_slider_image',
        array(
            'sanitize_callback' => 'esc_url_raw',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Image_Control( $wp_customize,'business_solutions_slider_image',
            array(
                'label' => __('Banner Image','business-solutions'),
                'section' => 'business_solutions_slider_section_settings',
                'settings' => 'business_solutions_slider_image',
            )
        )
    );

    // Customer Counters
    $wp_customize->add_setting('business_solutions_total_no_satisfied_customer', array(
        'default'           => '',
        'sanitize_callback' => 'sanitize_text_field',
    ));
    $wp_customize->add_control('business_solutions_total_no_satisfied_customer', array(
        'label'    => __('Add Total Number of Satisfied Customers', 'business-solutions'),
        'section'  => 'business_solutions_slider_section_settings',
        'type'     => 'text',
    ));

    $wp_customize->add_setting('business_solutions_total_no_award_win', array(
        'default'           => '',
        'sanitize_callback' => 'sanitize_text_field',
    ));
    $wp_customize->add_control('business_solutions_total_no_award_win', array(
        'label'    => __('Add Total Number of Award Wins', 'business-solutions'),
        'section'  => 'business_solutions_slider_section_settings',
        'type'     => 'text',
    ));

    $wp_customize->add_setting('business_solutions_total_no_successfull_projects', array(
        'default'           => '',
        'sanitize_callback' => 'sanitize_text_field',
    ));
    $wp_customize->add_control('business_solutions_total_no_successfull_projects', array(
        'label'    => __('Add Total Number of Successful Projects', 'business-solutions'),
        'section'  => 'business_solutions_slider_section_settings',
        'type'     => 'text',
    ));

    $wp_customize->add_setting('business_solutions_total_year_experience', array(
        'default'           => '',
        'sanitize_callback' => 'sanitize_text_field',
    ));
    $wp_customize->add_control('business_solutions_total_year_experience', array(
        'label'    => __('Add Total Years of Experience', 'business-solutions'),
        'section'  => 'business_solutions_slider_section_settings',
        'type'     => 'text',
    ));

    $wp_customize->add_setting('business_solutions_right_image_box_3_count', array(
        'default'           => '',
        'sanitize_callback' => 'sanitize_text_field',
    ));
    $wp_customize->add_control('business_solutions_right_image_box_3_count', array(
        'label'    => __('Review Count', 'business-solutions'),
        'section'  => 'business_solutions_slider_section_settings',
        'type'     => 'text',
    ));

    $wp_customize->add_setting('business_solutions_right_image_box_3_text', array(
        'default'           => '',
        'sanitize_callback' => 'sanitize_text_field',
    ));
    $wp_customize->add_control('business_solutions_right_image_box_3_text', array(
        'label'    => __('Review Text ( 3 words only )', 'business-solutions'),
        'section'  => 'business_solutions_slider_section_settings',
        'type'     => 'text',
    ));

    $wp_customize->add_setting('business_solutions_slider_team_image_1',
        array(
            'sanitize_callback' => 'esc_url_raw',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Image_Control( $wp_customize,'business_solutions_slider_team_image_1',
            array(
                'label' => __('Review Image 1','business-solutions'),
                'section' => 'business_solutions_slider_section_settings',
                'settings' => 'business_solutions_slider_team_image_1',
            )
        )
    );

    $wp_customize->add_setting('business_solutions_slider_team_image_2',
        array(
            'sanitize_callback' => 'esc_url_raw',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Image_Control( $wp_customize,'business_solutions_slider_team_image_2',
            array(
                'label' => __('Review Image 2','business-solutions'),
                'section' => 'business_solutions_slider_section_settings',
                'settings' => 'business_solutions_slider_team_image_2',
            )
        )
    );

    $wp_customize->add_setting('business_solutions_slider_team_image_3',
        array(
            'sanitize_callback' => 'esc_url_raw',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Image_Control( $wp_customize,'business_solutions_slider_team_image_3',
            array(
                'label' => __('Review Image 3','business-solutions'),
                'section' => 'business_solutions_slider_section_settings',
                'settings' => 'business_solutions_slider_team_image_3',
            )
        )
    );

    $wp_customize->add_setting('business_solutions_slider_team_image_4',
        array(
            'sanitize_callback' => 'esc_url_raw',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Image_Control( $wp_customize,'business_solutions_slider_team_image_4',
            array(
                'label' => __('Review Image 4','business-solutions'),
                'section' => 'business_solutions_slider_section_settings',
                'settings' => 'business_solutions_slider_team_image_4',
            )
        )
    );

    /** Classes Section Settings */
    $wp_customize->add_section(
        'business_solutions_classes_section_settings',
        array(
            'title' => esc_html__( 'Services Section Settings', 'business-solutions' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'business_solutions_home_page_settings',
        )
    );

    /** Classes Section control */
    $wp_customize->add_setting( 
        'business_solutions_classes_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_classes_setting',
        array(
            'label'       => __( 'Show Services Section', 'business-solutions' ),
            'section'     => 'business_solutions_classes_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Section Title
    $wp_customize->add_setting(
        'business_solutions_service_title', 
        array(
            'default'           => '',
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',    
            'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control(
        'business_solutions_service_title', 
        array(
            'label'       => __('Section Title', 'business-solutions'),
            'section'     => 'business_solutions_classes_section_settings',
            'settings'    => 'business_solutions_service_title',
            'type'        => 'text'
        )
    );

     // Section Text
    $wp_customize->add_setting(
        'business_solutions_service_text', 
        array(
            'default'           => '',
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',    
            'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control(
        'business_solutions_service_text', 
        array(
            'label'       => __('Section Text', 'business-solutions'),
            'section'     => 'business_solutions_classes_section_settings',
            'settings'    => 'business_solutions_service_text',
            'type'        => 'text'
        )
    );

    // Post Categories
    $categories = get_categories();
    $cat_posts = array();
    $default = '';
    $cat_posts[] = 'Select';
    foreach ($categories as $category) {
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting(
        'business_solutions_blog_args_',
        array(
            'default'            => 'select',
            'sanitize_callback'  => 'business_solutions_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'business_solutions_blog_args_',
        array(
            'type'     => 'select',
            'choices'  => $cat_posts,
            'label'    => __('Select Category to Display Services', 'business-solutions'),
            'section'  => 'business_solutions_classes_section_settings',
        )
    );


    for ($i=1; $i <= 10; $i++) {

    $wp_customize->add_setting('business_solutions_category_icon'.$i,array(
        'default'   => '',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Business_Solutions_Changeable_Icon(
        $wp_customize,'business_solutions_category_icon'.$i,array(
        'label' => __('Feature Icon ','business-solutions').$i,
        'transport' => 'refresh',
        'section'   => 'business_solutions_classes_section_settings',
        'type'      => 'icon'
    )));
}
    
    
    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'business_solutions_footer_section',
        array(
            'title' => __( 'Footer Settings', 'business-solutions' ),
            'priority' => 70,
            'panel' => 'business_solutions_home_page_settings',
        )
    );

    /** Footer Widget Columns */
    $wp_customize->add_setting('business_solutions_footer_widget_areas', array(
        'default'           => 4,
        'sanitize_callback' => 'business_solutions_sanitize_choices',
    ));

    $wp_customize->add_control('business_solutions_footer_widget_areas', array(
        'label'    => __('Footer Widget Columns', 'business-solutions'),
        'section'  => 'business_solutions_footer_section',
        'settings' => 'business_solutions_footer_widget_areas',
        'type'     => 'select',
        'choices'  => array(
		   '1'     => __('One', 'business-solutions'),
		   '2'     => __('Two', 'business-solutions'),
		   '3'     => __('Three', 'business-solutions'),
		   '4'     => __('Four', 'business-solutions')
        ),
    ));

    /** Footer Copyright control */
    $wp_customize->add_setting( 
        'business_solutions_footer_setting', 
        array(
            'default' => true,
            'sanitize_callback' => 'business_solutions_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'business_solutions_footer_setting',
        array(
            'label'       => __( 'Show Footer Copyright', 'business-solutions' ),
            'section'     => 'business_solutions_footer_section',
            'type'        => 'checkbox',
        )
    );
    
    /** Copyright Text */
    $wp_customize->add_setting(
        'business_solutions_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'business_solutions_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'business-solutions' ),
            'section' => 'business_solutions_footer_section',
            'type' => 'text',
        )
    );  
    $wp_customize->add_setting('business_solutions_footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );


    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'business_solutions_footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'business-solutions'),
                /* translators: 1: image width in pixels, 2: image height in pixels */
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'business-solutions'), 1024, 800),
                'section' => 'business_solutions_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('business_solutions_background_attatchment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'business_solutions_sanitize_choices',
    ));

    $wp_customize->add_control('business_solutions_background_attatchment', array(
        'label'    => __('Footer Background Attachment', 'business-solutions'),
        'section'  => 'business_solutions_footer_section',
        'settings' => 'business_solutions_background_attatchment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','business-solutions'),
            'scroll' => __('scroll','business-solutions'),
        ),
    ));

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'business_solutions_footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'business_solutions_footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'business-solutions'),
                'section' => 'business_solutions_footer_section',
                'type' => 'color',
            )
        )
    );

     $wp_customize->add_setting('business_solutions_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Business_Solutions_Changeable_Icon(
        $wp_customize,'business_solutions_scroll_icon',array(
        'label' => __('Scroll Top Icon','business-solutions'),
        'transport' => 'refresh',
        'section'   => 'business_solutions_footer_section',
        'type'      => 'icon'
    )));

        /** Scroll to top button shape */
    $wp_customize->add_setting('business_solutions_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'business_solutions_sanitize_choices',
    ));

    $wp_customize->add_control('business_solutions_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'business-solutions'),
        'section'  => 'business_solutions_footer_section',
        'settings' => 'business_solutions_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'business-solutions' ),
            'curved-box' => __( 'Curved Box', 'business-solutions' ),
            'circle'     => __( 'Circle', 'business-solutions' ),
        ),
    ));

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'business_solutions_404_section',
        array(
            'title' => __( '404 Page Settings', 'business-solutions' ),
            'priority' => 70,
            'panel' => 'business_solutions_general_settings',
        )
    );
   
    $wp_customize->add_setting('business_solutions_404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, 'business_solutions_404_page_image', array(
        'label' => __('404 Page Image', 'business-solutions'),
        'section' => 'business_solutions_404_section',
        'settings' => 'business_solutions_404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'business-solutions'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('Heading', 'business-solutions'),
        'section' => 'business_solutions_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'business-solutions'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('Heading', 'business-solutions'),
        'section' => 'business_solutions_404_section',
    ));

}
add_action( 'customize_register', 'business_solutions_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function business_solutions_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $business_solutions_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $business_solutions_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'business_solutions_customizer', get_template_directory_uri() . '/js' . $business_solutions_build . '/customizer' . $business_solutions_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'business_solutions_customize_preview_js' );